
# Qnap QTS GPL Kernel 4.2.8 内核编译

## 安装系统

1. Win10 的一些版本可以开启Linux 子系统，可以在linux 子系统下编译。可在网络上搜索安装过程
2. 安装虚拟机，安装Ubuntu 18.04
3. etc..

##安装工具

打开终端执行：

    sudo apt-get install build-essential libncurses-dev bison flex libssl-dev libelf-dev axel

## 使用axel下载SDK和内核

    axel https://sourceforge.net/projects/qosgpl/files/QNAP%20NAS%20GPL%20Source/QTS%204.3.4/GPL_QTS-4.3.4-20180531_Kernel.tar.gz/download

    axel https://sourceforge.net/projects/qosgpl/files/QNAP%20NAS%20Tool%20Chains/Cross%20Toolchain%20SDK%20%28x86%29%2020180115.tgz/download


## 解压SDK和内核

    tar xvf GPL_QTS-4.3.4-20180531_Kernel.tar.gz -C ~/
    tar xvf Cross\ Toolchain\ SDK\ \(x86\)\ 20180115.tgz -C ~/

`注1：~ 表示路径 /home/YOUNAME ,后面的命令依赖这个路径`

## 修改Makefile
在`~/GPL_QTS/src/linux-4.2`路径下

修改Makefile的第363行 CFLAGS_MODULE为：

    CFLAGS_MODULE   = -DTS1279U -DQNAP -DX86_SANDYBRIDGE -DNAS_VIRTUAL -DNAS_VIRTUAL_EX -DQNAP_FNOTIFY -DQNAP_SEARCH_FILENAME_CASE_INSENSITIVE -DQNAP_HAL -DSUPPORT_VAAI -DSUPPORT_TPC_CMD -DSUPPORT_FAST_BLOCK_CLONE -DSUPPORT_LOGICAL_BLOCK_4KB_FROM_NAS_GUI -DSUPPORT_CONCURRENT_TASKS -DSUPPORT_SINGLE_INIT_LOGIN -DVIRTUAL_JBOD -DSUPPORT_VOLUME_BASED -DQTS_HA -DSUPPORT_TP -DNFS_VAAI -DQNAP_SNAPSHOT -DISCSI_MULTI_INIT_ACL -DUSE_BLKDEV_READPAGES -DUSE_BLKDEV_WRITEPAGES -DKSWAPD_FIX -DQNAP_DEDUPE -DQNAP_KERNEL_STORAGE_V2 -DMODULE

修改Makefile的第366行 CFLAGS_KERNEL为：

    CFLAGS_KERNEL   = -DTS1279U -DQNAP -DX86_SANDYBRIDGE -DNAS_VIRTUAL -DNAS_VIRTUAL_EX -DQNAP_FNOTIFY -DQNAP_SEARCH_FILENAME_CASE_INSENSITIVE -DQNAP_HAL -DSUPPORT_VAAI -DSUPPORT_TPC_CMD -DSUPPORT_FAST_BLOCK_CLONE -DSUPPORT_LOGICAL_BLOCK_4KB_FROM_NAS_GUI -DSUPPORT_CONCURRENT_TASKS -DSUPPORT_SINGLE_INIT_LOGIN -DVIRTUAL_JBOD -DSUPPORT_VOLUME_BASED -DQTS_HA -DSUPPORT_TP -DNFS_VAAI -DQNAP_SNAPSHOT -DISCSI_MULTI_INIT_ACL -DUSE_BLKDEV_READPAGES -DUSE_BLKDEV_WRITEPAGES -DKSWAPD_FIX -DQNAP_DEDUPE -DQNAP_KERNEL_STORAGE_V2 -DCONFIG_QND_FNOTIFY_MODULE

`注1： CFLAGS_MODULE =  XXX 和 CFLAGS_KERNEL = XXX 各为一行，不要换行`
`注2： -DTS1279U 中TS1279U为机型，不改也没有影响，内核和驱动不依赖机型宏`

![](makefile.png)


## 修改编译配置

    cd ~/GPL_QTS/src/linux-4.2
    cp ../../kernel_cfg/TS-X53B/linux-4.2-x86_64.config .config
    export PATH=$PATH:~/x86_64-QNAP-linux-gnu/cross-tools/bin
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:~/x86_64-QNAP-linux-gnu/cross-tools/bin/lib
    export CROSS_COMPILE=x86_64-QNAP-linux-gnu-
    export ARCH=x86_64
    make menuconfig

`注1：TS-X53B为需要编译的目标机型，根据自己的情况到相应的机型下复制配置文件`

在 Device Driver 下，取消 Generic Target Core Mode的选择

![](target_core.png)

`注2：按空格切换选项，设置为不选择，如上图所示，记得保存配置`

## 编译内核和驱动
    export PATH=$PATH:~/x86_64-QNAP-linux-gnu/cross-tools/bin
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:~/x86_64-QNAP-linux-gnu/cross-tools/bin/lib
    export CROSS_COMPILE=x86_64-QNAP-linux-gnu-
    export ARCH=x86_64

    make clean
    make -j8